import QtQuick
import QtQuick.Window
import QtQuick3D
import QtQuick3D.Effects
import QtQuick.Layouts

Window {
    visible: true
    x: 50
    y: 50
    width: 1000
    height: 400
    title: qsTr("Model as importScene")

    Node {
        id: sceneRootNode
        Node {
            id: sceneRootNode2
            Model {
                id: sceneRootModel
                source: "#Sphere"
                x: 50
                materials: [
                    DefaultMaterial {
                        diffuseColor: "green"
                    }
                ]
                Model {
                    id: sceneRootModel2
                    source: "#Sphere"
                    x: 100
                    materials: [
                        PrincipledMaterial {
                            baseColor: "red"
                        }
                    ]
                }
            }
        }
    }

    Model {
        id: sceneRootModel3
        source: "#Sphere"
        x: 0
        materials: [
            PrincipledMaterial {
                baseColor: "yellow"
            }
        ]
    }

    View3D {
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        width: 200
        height: 200

        environment: sceneEnv
        PerspectiveCamera { z: 500 }
        DirectionalLight {}

        Model {
            id: sceneRootModel4
            source: "#Sphere"
            x: 0
            materials: [
                PrincipledMaterial {
                    baseColor: "cyan"
                }
            ]
        }

    }

    SceneEnvironment {
        id: sceneEnv
        backgroundMode: SceneEnvironment.Color
        clearColor: "lightgray"
    }

    RowLayout {
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.right: parent.right
        height: 200
        // If all views are uncommented, all are blank.
        // If just one view is uncommented, it shows the scene from importScene node down.
        // the importScene node is never shown, even if it's a Model

        // This view should show red and green ball
        View3D {
            width: 200
            height: 200
            importScene: sceneRootNode
            environment: sceneEnv
            PerspectiveCamera { z: 500 }
            DirectionalLight {}
        }

        // This view should show red and green ball
        View3D {
            width: 200
            height: 200
            importScene: sceneRootNode2
            environment: sceneEnv
            PerspectiveCamera { z: 500 }
            DirectionalLight {}
        }

//        // This view should show red and green ball
//        View3D {
//            width: 200
//            height: 200
//            importScene: sceneRootModel
//            environment: sceneEnv
//            PerspectiveCamera { z: 500 }
//            DirectionalLight {}
//        }

//        // This view should show just red ball
//        View3D {
//            width: 200
//            height: 200
//            importScene: sceneRootModel2
//            environment: sceneEnv
//            PerspectiveCamera { z: 500 }
//            DirectionalLight {}
//        }

//        // This view should show just yellow ball
//        View3D {
//            width: 200
//            height: 200
//            importScene: sceneRootModel3
//            environment: sceneEnv
//            PerspectiveCamera { z: 500 }
//            DirectionalLight {}
//        }

//        // This view should show just cyan ball
//        View3D {
//            width: 200
//            height: 200
//            importScene: sceneRootModel4
//            environment: sceneEnv
//            PerspectiveCamera { z: 500 }
//            DirectionalLight {}
//        }
    }


}
